<template lang="pug">
form.form( @submit.prevent='submit' )
	.field
		label.label.is-large.mb-4 {{$t("form.data")}}
	name-slug( v-model='brand' )
	hr
	meta-form( v-model='meta' )
	hr
	.field
		.control
			b-button( node="button" type="primary" fullwidth :loading='pending' ) {{ edit ? $t("buttons.change") : $t("buttons.create") }}
</template>

<script setup>
	import NameSlug from "@/components/NameSlug.vue"
	import MetaForm from "@/components/meta/Form.vue"

	import { onMounted, ref, computed, watch } from "vue"
	import { useBrandStore } from "@/stores/brand"
	import { useToast } from "vue-toastification"
	import { useI18n } from "vue-i18n"
	
	const props = defineProps({
		brand: Object,
		meta: Object,
		edit: Boolean
	})
	const emit = defineEmits([ "submit" ])

	const { t } = useI18n()
	const toast = useToast()
	const bs = useBrandStore()

	const brand = ref({ name: "", slug: "" })
	const meta = ref()

	const pending = computed(() => bs.pending)

	const submit = () => {
		if (bs.pending) return

		if (!brand.value.name || !brand.value.slug)
			return toast.warning(t("default.required_fields_incorrenct"))

		emit("submit", { brand: brand.value, meta: meta.value })
	}

	const setData = () => {
		if (props.brand) brand.value = props.brand
		if (props.meta) meta.value = props.meta
	}

	watch(() => [ props.brand, props.meta ], setData)
	onMounted(setData)
</script>

<style lang="scss"></style>